/*
	PIP - Platform Independent Primitives
	Resources subsystem
	Ivan Pelipenko peri4ko@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PIRESOURCES_P_H
#define PIRESOURCES_P_H

#include "pistring.h"
#include "pimap.h"
#include "pichunkstream.h"

class PIResources;

class PIP_EXPORT PIResourcesStorage {
	friend class PIResources;
public:

	static PIResourcesStorage * instance();

	struct PIP_EXPORT Section {
		Section();
		~Section();
		void add(const Section & s);
		void purge();
		PIMap<PIString, PIByteArray * > entries;
	};

	struct PIP_EXPORT __RCEntry {
		__RCEntry(const PIString & s = PIString(), const PIString & n = PIString(), const PIString & a = PIString(),
				  const PIString & f = PIString(), llong o = 0, llong si = 0, int fl = 0) {
			section = s;
			name = n;
			alias = a;
			file = f;
			offset = o;
			size = si;
			flags = fl;
		}
		PIString section;
		PIString name;
		PIString alias;
		PIString file;
		llong offset;
		llong size;
		int flags;
	};

	void registerSection(const PIString & section_name, const Section & data);
	void registerSection(const uchar * rc_data, const uchar * rc_desc, int rc_desc_size);
	Section * section(const PIString & section_name) const;
	PIByteArray get(const PIString & section_name, const PIString & entry_name) const;
	PIByteArray get(const PIString & entry_name) const;

	void clear();

private:
	PIResourcesStorage();
	~PIResourcesStorage();

	PIMap<PIString, Section * > sections;
};


BINARY_STREAM_WRITE(PIResourcesStorage::__RCEntry) {
	PIChunkStream cs;
	cs.add(1, v.section).add(2, v.name).add(3, v.file).add(4, v.size)
	  .add(5, v.offset).add(6, v.flags).add(7, v.alias);
	s << cs.data();
	return s;
}
BINARY_STREAM_READ (PIResourcesStorage::__RCEntry) {
	PIByteArray ba; s >> ba;
	PIChunkStream cs(ba);
	while (!cs.atEnd()) {
		switch (cs.read()) {
		case 1: cs.get(v.section); break;
		case 2: cs.get(v.name); break;
		case 3: cs.get(v.file); break;
		case 4: cs.get(v.size); break;
		case 5: cs.get(v.offset); break;
		case 6: cs.get(v.flags); break;
		case 7: cs.get(v.alias); break;
		}
	}
	return s;
}


#endif // PIRESOURCES_H
